diff --git a/thirdparty/singleapp/src/qtlocalpeer.cpp b/thirdparty/singleapp/src/qtlocalpeer.cpp
index 332b0643f..27260780a 100644
--- a/thirdparty/singleapp/src/qtlocalpeer.cpp
+++ b/thirdparty/singleapp/src/qtlocalpeer.cpp
@@ -156,7 +156,11 @@ bool QtLocalPeer::sendMessage(const QString &message, int timeout)
     if (!connOk)
         return false;
 
+#if defined(Q_OS_WIN)
+    QByteArray uMsg(message.toUtf16()); // see issue #287955
+#else
     QByteArray uMsg(message.toUtf8());
+#endif
     QDataStream ds(&socket);
     ds.writeBytes(uMsg.constData(), uMsg.size());
     bool res = socket.waitForBytesWritten(timeout);
@@ -194,7 +198,11 @@ void QtLocalPeer::receiveConnection()
         delete socket;
         return;
     }
+#if defined(Q_OS_WIN)
+    QString message(QString::fromUtf16(uMsg)); // see issue #287955
+#else
     QString message(QString::fromUtf8(uMsg));
+#endif
     socket->write(ack, qstrlen(ack));
     socket->waitForBytesWritten(1000);
     socket->waitForDisconnected(1000); // make sure client reads ack
